/*  Programik do gry w kropki.
 *  szabl3_chwil: generator chwilowych bezsensownych szablonow z wbudowanym szabl3_chwil
 *                NIE PRZYSPIESZA! (a nawet spowalnia)
 *  szabl2_chwil: generator chwilowych bezsensownych szablonow
 *
 *  Copyright (C) 2003,2005,2006 Bartek Dyda <kropki@yahoo.co.uk>.
 * 
 *  This file is part of Kropki.
 *
 *  Kropki is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License, version 2,
 *  as published by the Free Software Foundation.
 *
 *  Kropki is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License, version 2, for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Kropki; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#include <stdio.h>

// ,,a'' = 0 lub 1; ,,b'' = 0 lub 2
// szablony:
char sz[][10] ={
  " 20"
  "1.2"
  "11 ",   // numer 0

  "11 "
  "1.2"
  " 20",   // numer 1

  " 11"
  "2.1"
  "02 ",   // numer 2

  "02 "
  "2.1"
  " 11",   // numer 3



  " 2 "
  "1.1"
  "110",   // numer 4

  " 2 "
  "1.1"
  "011",   // numer 5

  "11 "
  "1.2"
  "01 ",   // numer 6

  "01 "
  "1.2"
  "11 ",   // numer 7

  "011"
  "1.1"
  " 2 ",   // numer 8

  "110"
  "1.1"
  " 2 ",   // numer 9

  " 11"
  "2.1"
  " 10",   // numer 10

  " 10"
  "2.1"
  " 11",   // numer 11



  " 1a"
  "0.1"
  "a1a",   // numer 12

  " 0a"
  "1.1"
  "a1a",   // numer 13

  " 1a"
  "1.0"
  "a1a",   // numer 14

  " 1a"
  "1.1"
  "a0a",   // numer 15


  "a1 "
  "0.1"
  "a1a",   // numer 16

  "a0 "
  "1.1"
  "a1a",   // numer 17

  "a1 "
  "1.0"
  "a1a",   // numer 18

  "a1 "
  "1.1"
  "a0a",   // numer 19



  "a1a"
  "0.1"
  "a1 ",   // numer 20

  "a0a"
  "1.1"
  "a1 ",   // numer 21

  "a1a"
  "1.0"
  "a1 ",   // numer 22

  "a1a"
  "1.1"
  "a0 ",   // numer 23



  "a1a"
  "0.1"
  " 1a",   // numer 24

  "a0a"
  "1.1"
  " 1a",   // numer 25

  "a1a"
  "1.0"
  " 1a",   // numer 26

  "a1a"
  "1.1"
  " 0a",   // numer 27


  // te ponizej wydaja sie juz niepotrzebne...

  "a  "
  "1.1"
  "110",   // numer 28

  "a11"
  " .1"
  " 10",   // numer 29

  "  a"
  "1.1"
  "011",   // numer 30

  "11a"
  "1. "
  "01 ",   // numer 31

  "011"
  "1.1"
  "  a",   // numer 32

  "01 "
  "1. "
  "11a",   // numer 33

  "110"
  "1.1"
  "a  ",   // numer 34

  " 10"
  " .1"
  "a11",   // numer 35



  "  a"
  "1.1"
  "110",   // numer 36

  " 11"
  " .1"
  "a10",   // numer 37

  "a  "
  "1.1"
  "011",   // numer 38

  "11 "
  "1. "
  "01a",   // numer 39

  "011"
  "1.1"
  "a  ",   // numer 40

  "01a"
  "1. "
  "11 ",   // numer 41

  "110"
  "1.1"
  "  a",   // numer 42

  "a10"
  " .1"
  " 11",   // numer 43


  // chwilowo bezsensowne dla gracza 1 (dla gracza 2 przesuniete maski)
  " 1 "
  "1.1"
  " 0 ",   // numer 44

  " 1 "
  "1.0"
  " 1 ",   // numer 45

  " 0 "
  "1.1"
  " 1 ",   // numer 46

  " 1 "
  "0.1"
  " 1 ",   // numer 47


  "aa0"
  "1.a"
  "11a",   // numer 48 (dosc asekuracyjny szablon)

  "11a"
  "1.a"
  "aa0",   // numer 49 (dosc asekuracyjny szablon)

  "a11"
  "a.1"
  "0aa",   // numer 50 (dosc asekuracyjny szablon)

  "0aa"
  "a.1"
  "a11"   // numer 51 (dosc asekuracyjny szablon)

};

int ile_sz=44;
int ile_sz_1gr=8;

// numeracja pol:
//   0 1 2
//   3 4 5
//   6 7 8
// oczywiscie nie ma znaczenia, gdzie jest os x, a gdzie y (symetria)

int CzyOK(int nr_sz, int co, int pole)
// czy na polu (pole) w szablonie (nr_sz) moze stac (co)
//  co==0 -- puste pole, co==1,2 -- kropka gracza 1,2
{
 if (sz[nr_sz][pole]==' ')
   return 1;
 switch (co)
   {
   case 0:  return (sz[nr_sz][pole]!='1' && sz[nr_sz][pole]!='2');  // moze byc: 0.ab
   case 1:  return (sz[nr_sz][pole]=='1' || sz[nr_sz][pole]=='a');
   case 2:  return (sz[nr_sz][pole]=='2' || sz[nr_sz][pole]=='b');
   }
}

void UstawBit(unsigned long long int& maska, int nrb)
{
 maska |= (((unsigned long long) 1)<<nrb);
}

int main()
{
 unsigned long long int m1=0, m2=0;   // maska bezs dla 1,2 gracza
 for (int nr_sz=0; nr_sz<ile_sz; nr_sz++) {
   UstawBit(m1, nr_sz);   
   UstawBit(m2, nr_sz);
 }
 for (int nr_sz=ile_sz; nr_sz<ile_sz+ile_sz_1gr; nr_sz++) {
   UstawBit(m1, nr_sz);
   UstawBit(m2, nr_sz + ile_sz_1gr);      // WAZNE!
 }

 for (int pole=0; pole<9; pole++)
   if (pole!=4)   {
   printf("{");
   for (int co=0; co<=2; co++)
     {
     unsigned long long int maska=0;
     for (int nr_sz=0; nr_sz<ile_sz; nr_sz++)
       if (CzyOK(nr_sz, co, pole))
         UstawBit(maska, nr_sz);
     for (int nr_sz=ile_sz; nr_sz<ile_sz+ile_sz_1gr; nr_sz++)
       if (CzyOK(nr_sz, co, pole))
         UstawBit(maska, nr_sz);
     printf("0x%06llxULL%s ",maska, co<2?",":"");
     }
   printf("},\n");
   }
 // jeszcze raz z zamienionymi graczami: 1<-->2
 int zamienione[3]={0,2,1};
 for (int pole=0; pole<9; pole++)
   if (pole!=4)   {
   printf("{");
   for (int co=0; co<=2; co++)
     {
     unsigned long long int maska=0;
     for (int nr_sz=0; nr_sz<ile_sz; nr_sz++)
       if (CzyOK(nr_sz, zamienione[co], pole))
         UstawBit(maska, nr_sz);
     for (int nr_sz=ile_sz; nr_sz<ile_sz+ile_sz_1gr; nr_sz++)
       if (CzyOK(nr_sz, co, pole))
         UstawBit(maska, nr_sz+ile_sz_1gr);
     printf("0x%06llxULL%s ",maska, co<2?",":"");
     }
   printf("},\n");
   }
 printf("unsigned long long int maski[3]= {0x%06llxULL, 0x%06llxULL, 0x%06llxULL};\n",
	m1&m2, m1,m2);
return 0;
}



